/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreMissingvalue.TCoreMissingvaluePath;
import de.ship.db.tables.records.TCoreMissingclassRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreMissingclass extends TableImpl<TCoreMissingclassRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_missingclass</code>
     */
    public static final TCoreMissingclass T_CORE_MISSINGCLASS = new TCoreMissingclass();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreMissingclassRecord> getRecordType() {
        return TCoreMissingclassRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_missingclass.lastchange</code>.
     */
    public final TableField<TCoreMissingclassRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_missingclass.pk</code>. id of missing
     * class
     */
    public final TableField<TCoreMissingclassRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "id of missing class");

    /**
     * The column <code>common_dd.t_core_missingclass.name</code>. name for this
     * missing class
     */
    public final TableField<TCoreMissingclassRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "name for this missing class");

    private TCoreMissingclass(Name alias, Table<TCoreMissingclassRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreMissingclass(Name alias, Table<TCoreMissingclassRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_missingclass</code> table
     * reference
     */
    public TCoreMissingclass(String alias) {
        this(DSL.name(alias), T_CORE_MISSINGCLASS);
    }

    /**
     * Create an aliased <code>common_dd.t_core_missingclass</code> table
     * reference
     */
    public TCoreMissingclass(Name alias) {
        this(alias, T_CORE_MISSINGCLASS);
    }

    /**
     * Create a <code>common_dd.t_core_missingclass</code> table reference
     */
    public TCoreMissingclass() {
        this(DSL.name("t_core_missingclass"), null);
    }

    public <O extends Record> TCoreMissingclass(Table<O> path, ForeignKey<O, TCoreMissingclassRecord> childPath, InverseForeignKey<O, TCoreMissingclassRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_MISSINGCLASS);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreMissingclassPath extends TCoreMissingclass implements Path<TCoreMissingclassRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreMissingclassPath(Table<O> path, ForeignKey<O, TCoreMissingclassRecord> childPath, InverseForeignKey<O, TCoreMissingclassRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreMissingclassPath(Name alias, Table<TCoreMissingclassRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreMissingclassPath as(String alias) {
            return new TCoreMissingclassPath(DSL.name(alias), this);
        }

        @Override
        public TCoreMissingclassPath as(Name alias) {
            return new TCoreMissingclassPath(alias, this);
        }

        @Override
        public TCoreMissingclassPath as(Table<?> alias) {
            return new TCoreMissingclassPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreMissingclassRecord, Integer> getIdentity() {
        return (Identity<TCoreMissingclassRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreMissingclassRecord> getPrimaryKey() {
        return Keys.PK_CORE_MISSINGCLASS;
    }

    private transient TCoreMissingvaluePath _fkMissingclass;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_missingvalue</code> table, via the
     * <code>fk_missingclass</code> key
     */
    public TCoreMissingvaluePath fkMissingclass() {
        if (_fkMissingclass == null)
            _fkMissingclass = new TCoreMissingvaluePath(this, null, Keys.T_CORE_MISSINGVALUE__FK_MISSINGCLASS.getInverseKey());

        return _fkMissingclass;
    }

    private transient TCoreMissingvaluePath _tCoreMissingvalueFkMissingclassQsFkey;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_missingvalue</code> table, via the
     * <code>t_core_missingvalue_fk_missingclass_qs_fkey</code> key
     */
    public TCoreMissingvaluePath tCoreMissingvalueFkMissingclassQsFkey() {
        if (_tCoreMissingvalueFkMissingclassQsFkey == null)
            _tCoreMissingvalueFkMissingclassQsFkey = new TCoreMissingvaluePath(this, null, Keys.T_CORE_MISSINGVALUE__T_CORE_MISSINGVALUE_FK_MISSINGCLASS_QS_FKEY.getInverseKey());

        return _tCoreMissingvalueFkMissingclassQsFkey;
    }

    @Override
    public TCoreMissingclass as(String alias) {
        return new TCoreMissingclass(DSL.name(alias), this);
    }

    @Override
    public TCoreMissingclass as(Name alias) {
        return new TCoreMissingclass(alias, this);
    }

    @Override
    public TCoreMissingclass as(Table<?> alias) {
        return new TCoreMissingclass(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingclass rename(String name) {
        return new TCoreMissingclass(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingclass rename(Name name) {
        return new TCoreMissingclass(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingclass rename(Table<?> name) {
        return new TCoreMissingclass(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingclass where(Condition condition) {
        return new TCoreMissingclass(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingclass where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingclass where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingclass where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingclass where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingclass where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingclass where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingclass where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingclass whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingclass whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
